#include <iostream>

using namespace std;

long long nzd(long long x,long long y)
{
    long long a=x,b=y,c;
    while(b!=0)
    {
        c=a%b;
        a=b;
        b=c;
    }
    if(a>0) return a;
    else return -a;
}

int main()
{
    int t,i;
    int n,m,j;
    long long a1,a;
    long long b;
    long long x;
    int ok;
    cin>>t;
    for(i=0;i<t;i++)
    {
        cin>>n>>m;
        cin>>a1;
        cin>>a;
        x=a-a1;
        for(j=2;j<n;j++)
        {
            cin>>a;
            x=nzd(a-a1,x);
        }
        ok=1;
        for(j=0;j<m;j++)
        {
            cin>>b;
            if((b-a1)%x==0) ok=0;
        }
        cout<<ok<<endl;
    }
    return 0;
}